#include "Error_dict.h"

AFun ERR_afun8;
AFun ERR_afun4;
AFun ERR_afun0;
AFun ERR_afun2;
AFun ERR_afun7;
AFun ERR_afun5;
AFun ERR_afun3;
AFun ERR_afun9;
AFun ERR_afun1;
AFun ERR_afun6;

ATerm ERR_patternAreaArea = NULL;
ATerm ERR_patternLocationAreaInFile = NULL;
ATerm ERR_patternLocationFile = NULL;
ATerm ERR_patternErrorListMany = NULL;
ATerm ERR_patternErrorListSingle = NULL;
ATerm ERR_patternErrorListEmpty = NULL;
ATerm ERR_patternSummarySummary = NULL;
ATerm ERR_patternSubjectListMany = NULL;
ATerm ERR_patternSubjectListSingle = NULL;
ATerm ERR_patternSubjectListEmpty = NULL;
ATerm ERR_patternErrorFatal = NULL;
ATerm ERR_patternErrorError = NULL;
ATerm ERR_patternErrorWarning = NULL;
ATerm ERR_patternErrorInfo = NULL;
ATerm ERR_patternSubjectLocalized = NULL;
ATerm ERR_patternSubjectSubject = NULL;
ATerm ERR_patternNatConNatCon = NULL;
ATerm ERR_patternStrConStrCon = NULL;
ATerm ERR_patternEscapedEscaped = NULL;
ATerm ERR_patternNormalNormal = NULL;

/*
 * ERR_afun8 = area-in-file(x,x)
 * ERR_afun4 = error(x,x)
 * ERR_afun0 = subject(x)
 * ERR_afun2 = info(x,x)
 * ERR_afun7 = file(x)
 * ERR_afun5 = fatal(x,x)
 * ERR_afun3 = warning(x,x)
 * ERR_afun9 = area(x,x,x,x,x,x)
 * ERR_afun1 = localized(x,x)
 * ERR_afun6 = summary(x,x,x)
 *
 * ERR_patternAreaArea = area(<int>,<int>,<int>,<int>,<int>,<int>)
 * ERR_patternLocationAreaInFile = area-in-file(<str>,<term>)
 * ERR_patternLocationFile = file(<str>)
 * ERR_patternErrorListMany = [<term>,<list>]
 * ERR_patternErrorListSingle = [<term>]
 * ERR_patternErrorListEmpty = []
 * ERR_patternSummarySummary = summary(<str>,<str>,<term>)
 * ERR_patternSubjectListMany = [<term>,<list>]
 * ERR_patternSubjectListSingle = [<term>]
 * ERR_patternSubjectListEmpty = []
 * ERR_patternErrorFatal = fatal(<str>,<term>)
 * ERR_patternErrorError = error(<str>,<term>)
 * ERR_patternErrorWarning = warning(<str>,<term>)
 * ERR_patternErrorInfo = info(<str>,<term>)
 * ERR_patternSubjectLocalized = localized(<str>,<term>)
 * ERR_patternSubjectSubject = subject(<str>)
 * ERR_patternNatConNatCon = <str>
 * ERR_patternStrConStrCon = <str>
 * ERR_patternEscapedEscaped = <str>
 * ERR_patternNormalNormal = <str>
 *
 */

static ATerm _Error_dict = NULL;

#define _Error_dict_LEN 343

static char _Error_dict_baf[_Error_dict_LEN] = {
0x00,0x8B,0xAF,0x83,0x00,0x12,0x41,0x03,0x3C,0x5F,0x3E,0x01,0x00,0x04,0x04,0x05,
0x06,0x04,0x03,0x05,0x5B,0x5F,0x2C,0x5F,0x5D,0x02,0x00,0x23,0x0D,0x01,0x02,0x00,
0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,0x10,0x11,0x02,0x01,0x02,0x02,0x5B,0x5D,
0x00,0x00,0x01,0x03,0x69,0x6E,0x74,0x00,0x00,0x01,0x03,0x73,0x74,0x72,0x00,0x00,
0x01,0x04,0x6C,0x69,0x73,0x74,0x00,0x00,0x01,0x04,0x74,0x65,0x72,0x6D,0x00,0x00,
0x01,0x01,0x78,0x00,0x00,0x01,0x0C,0x61,0x72,0x65,0x61,0x2D,0x69,0x6E,0x2D,0x66,
0x69,0x6C,0x65,0x02,0x00,0x02,0x02,0x00,0x07,0x02,0x00,0x07,0x05,0x65,0x72,0x72,
0x6F,0x72,0x02,0x00,0x02,0x02,0x00,0x07,0x02,0x00,0x07,0x07,0x73,0x75,0x62,0x6A,
0x65,0x63,0x74,0x01,0x00,0x02,0x02,0x00,0x07,0x04,0x69,0x6E,0x66,0x6F,0x02,0x00,
0x02,0x02,0x00,0x07,0x02,0x00,0x07,0x04,0x66,0x69,0x6C,0x65,0x01,0x00,0x02,0x02,
0x00,0x07,0x05,0x66,0x61,0x74,0x61,0x6C,0x02,0x00,0x02,0x02,0x00,0x07,0x02,0x00,
0x07,0x07,0x77,0x61,0x72,0x6E,0x69,0x6E,0x67,0x02,0x00,0x02,0x02,0x00,0x07,0x02,
0x00,0x07,0x04,0x61,0x72,0x65,0x61,0x06,0x00,0x02,0x02,0x00,0x07,0x02,0x00,0x07,
0x02,0x00,0x07,0x02,0x00,0x07,0x02,0x00,0x07,0x02,0x00,0x07,0x09,0x6C,0x6F,0x63,
0x61,0x6C,0x69,0x7A,0x65,0x64,0x02,0x00,0x02,0x02,0x00,0x07,0x02,0x00,0x07,0x07,
0x73,0x75,0x6D,0x6D,0x61,0x72,0x79,0x03,0x00,0x02,0x02,0x00,0x07,0x02,0x00,0x07,
0x02,0x00,0x07,0x01,0x09,0x30,0xA0,0x42,0x28,0xE2,0x88,0x61,0x8A,0x28,0xE2,0x08,
0x12,0x8C,0x24,0xA1,0x05,0x2A,0xA8,0x83,0x4A,0x00,0x32,0xA8,0x84,0x01,0x58,0x18,
0x00,0x00,0x00,0x7D,0x91,0x10,0xA0,0xF7,0x44,0x2E,0x0D,0x11,0x0A,0x26,0x10,0x70,
0x18,0x8A,0x36,0x81,0x63,0x88,0x41,0x13,0x06,0x80,0xC0,0x61,0xD4,0x0D,0x0C,0x41,
0x15,0x14,0x41,0x05,0x4C,0x41,0x19,0x34,0x41,0x09,0x6C,0x41,0x11,0x54,0x40,0x24,
0x87,0x89,0x07,0x12,0x16,0x24,0xA0
};

void init_Error_dict()
{
  ATermList afuns, terms;

  _Error_dict = ATreadFromBinaryString(_Error_dict_baf, _Error_dict_LEN);

  ATprotect(&_Error_dict);

  afuns = (ATermList)ATelementAt((ATermList)_Error_dict, 0);

  ERR_afun8 = ATgetAFun((ATermAppl)ATgetFirst(afuns));
  afuns = ATgetNext(afuns);
  ERR_afun4 = ATgetAFun((ATermAppl)ATgetFirst(afuns));
  afuns = ATgetNext(afuns);
  ERR_afun0 = ATgetAFun((ATermAppl)ATgetFirst(afuns));
  afuns = ATgetNext(afuns);
  ERR_afun2 = ATgetAFun((ATermAppl)ATgetFirst(afuns));
  afuns = ATgetNext(afuns);
  ERR_afun7 = ATgetAFun((ATermAppl)ATgetFirst(afuns));
  afuns = ATgetNext(afuns);
  ERR_afun5 = ATgetAFun((ATermAppl)ATgetFirst(afuns));
  afuns = ATgetNext(afuns);
  ERR_afun3 = ATgetAFun((ATermAppl)ATgetFirst(afuns));
  afuns = ATgetNext(afuns);
  ERR_afun9 = ATgetAFun((ATermAppl)ATgetFirst(afuns));
  afuns = ATgetNext(afuns);
  ERR_afun1 = ATgetAFun((ATermAppl)ATgetFirst(afuns));
  afuns = ATgetNext(afuns);
  ERR_afun6 = ATgetAFun((ATermAppl)ATgetFirst(afuns));
  afuns = ATgetNext(afuns);

  terms = (ATermList)ATelementAt((ATermList)_Error_dict, 1);

  ERR_patternAreaArea = ATgetFirst(terms);
  terms = ATgetNext(terms);
  ERR_patternLocationAreaInFile = ATgetFirst(terms);
  terms = ATgetNext(terms);
  ERR_patternLocationFile = ATgetFirst(terms);
  terms = ATgetNext(terms);
  ERR_patternErrorListMany = ATgetFirst(terms);
  terms = ATgetNext(terms);
  ERR_patternErrorListSingle = ATgetFirst(terms);
  terms = ATgetNext(terms);
  ERR_patternErrorListEmpty = ATgetFirst(terms);
  terms = ATgetNext(terms);
  ERR_patternSummarySummary = ATgetFirst(terms);
  terms = ATgetNext(terms);
  ERR_patternSubjectListMany = ATgetFirst(terms);
  terms = ATgetNext(terms);
  ERR_patternSubjectListSingle = ATgetFirst(terms);
  terms = ATgetNext(terms);
  ERR_patternSubjectListEmpty = ATgetFirst(terms);
  terms = ATgetNext(terms);
  ERR_patternErrorFatal = ATgetFirst(terms);
  terms = ATgetNext(terms);
  ERR_patternErrorError = ATgetFirst(terms);
  terms = ATgetNext(terms);
  ERR_patternErrorWarning = ATgetFirst(terms);
  terms = ATgetNext(terms);
  ERR_patternErrorInfo = ATgetFirst(terms);
  terms = ATgetNext(terms);
  ERR_patternSubjectLocalized = ATgetFirst(terms);
  terms = ATgetNext(terms);
  ERR_patternSubjectSubject = ATgetFirst(terms);
  terms = ATgetNext(terms);
  ERR_patternNatConNatCon = ATgetFirst(terms);
  terms = ATgetNext(terms);
  ERR_patternStrConStrCon = ATgetFirst(terms);
  terms = ATgetNext(terms);
  ERR_patternEscapedEscaped = ATgetFirst(terms);
  terms = ATgetNext(terms);
  ERR_patternNormalNormal = ATgetFirst(terms);
  terms = ATgetNext(terms);
}
