#include "Location_dict.h"

AFun LOC_afun0;
AFun LOC_afun2;
AFun LOC_afun1;

ATerm LOC_patternAreaArea = NULL;
ATerm LOC_patternLocationAreaInFile = NULL;
ATerm LOC_patternLocationFile = NULL;
ATerm LOC_patternNatConNatCon = NULL;
ATerm LOC_patternStrConStrCon = NULL;
ATerm LOC_patternEscapedEscaped = NULL;
ATerm LOC_patternNormalNormal = NULL;

/*
 * LOC_afun0 = file(x)
 * LOC_afun2 = area(x,x,x,x,x,x)
 * LOC_afun1 = area-in-file(x,x)
 *
 * LOC_patternAreaArea = area(<int>,<int>,<int>,<int>,<int>,<int>)
 * LOC_patternLocationAreaInFile = area-in-file(<str>,<term>)
 * LOC_patternLocationFile = file(<str>)
 * LOC_patternNatConNatCon = <str>
 * LOC_patternStrConStrCon = <str>
 * LOC_patternEscapedEscaped = <str>
 * LOC_patternNormalNormal = <str>
 *
 */

static ATerm _Location_dict = NULL;

#define _Location_dict_LEN 152

static char _Location_dict_baf[_Location_dict_LEN] = {
0x00,0x8B,0xAF,0x83,0x00,0x0A,0x1A,0x03,0x3C,0x5F,0x3E,0x01,0x00,0x03,0x03,0x05,
0x04,0x03,0x05,0x5B,0x5F,0x2C,0x5F,0x5D,0x02,0x00,0x0C,0x05,0x01,0x00,0x07,0x08,
0x09,0x02,0x01,0x02,0x02,0x5B,0x5D,0x00,0x00,0x01,0x03,0x69,0x6E,0x74,0x00,0x00,
0x01,0x03,0x73,0x74,0x72,0x00,0x00,0x01,0x04,0x74,0x65,0x72,0x6D,0x00,0x00,0x01,
0x01,0x78,0x00,0x00,0x01,0x04,0x66,0x69,0x6C,0x65,0x01,0x00,0x02,0x02,0x00,0x06,
0x04,0x61,0x72,0x65,0x61,0x06,0x00,0x02,0x02,0x00,0x06,0x02,0x00,0x06,0x02,0x00,
0x06,0x02,0x00,0x06,0x02,0x00,0x06,0x02,0x00,0x06,0x0C,0x61,0x72,0x65,0x61,0x2D,
0x69,0x6E,0x2D,0x66,0x69,0x6C,0x65,0x02,0x00,0x02,0x02,0x00,0x06,0x02,0x00,0x06,
0x01,0x08,0x88,0x8C,0x55,0x50,0x04,0xA8,0x51,0x3A,0x04,0x00,0x00,0x01,0x31,0x42,
0x1C,0xA2,0x1A,0x45,0x48,0x29,0x19,0x2A
};

void init_Location_dict()
{
  ATermList afuns, terms;

  _Location_dict = ATreadFromBinaryString(_Location_dict_baf, _Location_dict_LEN);

  ATprotect(&_Location_dict);

  afuns = (ATermList)ATelementAt((ATermList)_Location_dict, 0);

  LOC_afun0 = ATgetAFun((ATermAppl)ATgetFirst(afuns));
  afuns = ATgetNext(afuns);
  LOC_afun2 = ATgetAFun((ATermAppl)ATgetFirst(afuns));
  afuns = ATgetNext(afuns);
  LOC_afun1 = ATgetAFun((ATermAppl)ATgetFirst(afuns));
  afuns = ATgetNext(afuns);

  terms = (ATermList)ATelementAt((ATermList)_Location_dict, 1);

  LOC_patternAreaArea = ATgetFirst(terms);
  terms = ATgetNext(terms);
  LOC_patternLocationAreaInFile = ATgetFirst(terms);
  terms = ATgetNext(terms);
  LOC_patternLocationFile = ATgetFirst(terms);
  terms = ATgetNext(terms);
  LOC_patternNatConNatCon = ATgetFirst(terms);
  terms = ATgetNext(terms);
  LOC_patternStrConStrCon = ATgetFirst(terms);
  terms = ATgetNext(terms);
  LOC_patternEscapedEscaped = ATgetFirst(terms);
  terms = ATgetNext(terms);
  LOC_patternNormalNormal = ATgetFirst(terms);
  terms = ATgetNext(terms);
}
